{----------------------------------------------------------------------------
  SBFB CtH[
	
	[ʍ\]
  j[
  sgTitle:TStringGrid;    FAQ̃^Cgi[FAQ]ȍ~̕j\
                          NbNƂFAQ\
  mQuestion:TMemo;        FAQ̎e\
  mAnswer:TMemo;          FAQ̉񓚓e\
  VSplitPanel1,2:TPanel   ʂ̈̕ύXppl
                          VSplitPanel2̂ق͂܂@\Ă܂B
                          KɒĂ(^^;)
-----------------------------------------------------------------------------}

unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, ExtCtrls, Grids,jstr2,Config;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    FileMenu: TMenuItem;
    ItemOpen: TMenuItem;
    ItemSetup: TMenuItem;
    ItemQuit: TMenuItem;
    TitlePanel: TPanel;
    Label1: TLabel;
    sgTitle: TStringGrid;
    VSplitPanel1: TPanel;
    mQuestion: TMemo;
    VsplitPanel2: TPanel;
    AnswerPanel: TPanel;
    mAnswer: TMemo;
    OpenDlg: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure ItemOpenClick(Sender: TObject);
    procedure TitlePanelDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sgTitleClick(Sender: TObject);
    procedure ItemQuitClick(Sender: TObject);
    procedure ItemSetupClick(Sender: TObject);
    procedure mAnswerDragDrop(Sender, Source: TObject; X, Y: Integer);
  private
    faqT,
    faqQ,
    faqA: TstringList;{e؂蕪f[^Xg}
    FLog: TStringList;{O؂of[^}
    procedure ParseLogFile;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  FLog := TStringList.Create;
  faqT := TstringList.Create;
  faqQ := TstringList.Create;
  faqA := TstringList.Create;
  sgTitle.Height := sgTitle.DefaultRowHeight*4+4;
end;

procedure TForm1.ItemOpenClick(Sender: TObject);
var
  TF: TextFile;
  LogFile : string;
  s: string;
  i: integer;
begin
  if not OpenDlg.Execute then exit;
  LogFile := OpenDlg.FileName;
  {FLogɃOf[^i[}
  assignFile(TF,LogFile);
  reset(TF);
  while not eof(TF) do begin
    ReadLn(TF,S);
    FLog.Add(S);
  end;
  closeFile(TF);
  {O؂蕪鏈}
  ParseLogFile;

  FLog.Free;
  sgTitle.OnClick(sgTitle);
  
  {[^Cg]A[p]A[`]̕t@CɗƂĂ}
  s := extractFilePath(application.exename);
  faqT.SaveToFile(s+'FAQT.TXT');{񗧏㎞ɂ͂̐؂of[^}
  faqQ.SaveToFile(s+'FAQQ.TXT');{p悤ɂ΂Ȃ}
  faqA.SaveToFile(s+'FAQA.TXT');
end;

const
  cSBORLAND ='- SBORLAND  MES(16):';
  cSTATEMENT = '[FAQ]';
  cTITLE = '[^Cg]';
  cQUESTION = '[p]';
  cANSWER = '[`]';
  cEXAMPLE = '[]';
  cFINISH = '[dmc]';
  cComment = '̃Rg';{'w̃Rg'Ƃē삳pos֐
                          ܂EȂ̂ŁAȊłĂ܂B
                          ͕̂܂BJPosg΂
                          }
  cSectionStart = '[';

{̃^Cgsǂ𔻒f}
function IsNewStatement(s:string):boolean;
var
  i: byte;
begin
  {Vڂ܂łAor'/'Ŗ΃^Cgsł͂Ȃ}
  for i := 1 to 7 do
    if (not (s[i] in ['0'..'9','/'])) then begin
      result := false;
      exit;
    end;
  {[FAQ]39ڂn܂ĂȂFAQł͂Ȃ}
  if (pos(cSTATEMENT,s) = 39) then result := true
  else result := false
end;

{Rgł邩ǂ𔻒f}
{Rg̔No.ԂBVK̏ꍇ0Ԃ}
function IsComment(s:string):Word;
var
  ts,NumStr: string;
  c: byte;
begin
  c := Jpos(cComment,s);
  if (Length(s) < 24) or
     (pos('(16)',s) <> 1) or
     (c = 0) then begin
    result := 0;
    exit;
  end;
  NumStr := copy(s,24,c-26);
  if NumStr = '' then result := 0
  else result := StrToInt(NumStr);
end;

{Of[^̐؂蕪}
procedure TForm1.ParseLogFile;
var
  s,s2: string;
  i,j,k,l,
  currentPos: word;
  TitleMode,
  NewStatement,
  CommentEnd,
  CommentMode: boolean;
  titleIndex: word;
  CommentStrList: TstringList;
  Mode: byte;
  CommentPos:byte;
  CommentNo: Word;
begin
  titleIndex := 0;
  TitleMode := false;
  CommentMode := false;
  CommentEnd := false;
  CommentStrList := NIL;
  j := FLog.Count-1;
  i := 0;
  repeat
    s := Flog.Strings[i];
    {̃^Cgso}
    if (not TitleMode) and (not CommentMode) and IsNewStatement(s) then begin
      inc(TitleIndex);
      {Rg̃`FbN}
      inc(i);
      s2 := FLog.Strings[i];
      commentNo := IsComment(s2);
      TitleMode := true;
      {Z̍s𑝂₵ĂZɑ}
      if TitleIndex > sgTitle.RowCount then
        sgTitle.RowCount := sgTitle.RowCount + 1;
      sgTitle.Cells[0,TitleIndex] := IntToStr(TitleIndex);
      sgTitle.Cells[1,TitleIndex] := copy(s,pos(cSTATEMENT,s),255);
      sgTitle.Cells[2,TitleIndex] := copy(s,1,pos('/',s)-1);
      sgTitle.Cells[3,TitleIndex] := IntToStr(commentNo);
    end;
    {[^Cg]`[END]CommentStrList}
    if TitleMode and (not CommentMode) and (Copy(s,1,10) = cTITLE) then begin
      if CommentStrList = NIL then CommentStrList := TStringList.Create;
      CommentMode := true;
      repeat
          s := FLog.Strings[i];
          CommentStrList.Add(s);
          inc(i);
      until Copy(s,1,8) = cFINISH;
      CommentStrList.Add(s);
      CommentEnd := true;
    end;
    {[^Cg]`[END]͂ĕۑ
     ^Cg :faqT
     e :faqQ
          :faqA }
    if CommentEnd then begin
      CommentEnd := false;
      TitleMode := false;
      CommentMode := false;
      l := CommentStrList.Count - 1;
      k := 0;
      repeat
        {^CgZNVXgɒǉ}
        if pos(cTITLE,CommentStrList[k]) = 1 then begin
          faqT.add('[FAQ'+IntToStr(TitleIndex)+']');
          repeat
            faqT.add(CommentStrList[k]);
            inc(k);
          until Copy(CommentStrList[k],1,1) = cSectionStart;
          dec(k);
        end;
        {ZNVXgɒǉ}
        if pos(cQUESTION,CommentStrList[k]) = 1 then begin
          faqQ.add('[Q'+IntToStr(TitleIndex)+']');
          repeat
            faqQ.add(CommentStrList[k]);
            inc(k);
          until Copy(CommentStrList[k],1,1) = cSectionStart;
          dec(k);
        end;
        {񓚃ZNV`[dmc]܂łXgɒǉ}
        if (pos(cANSWER,CommentStrList[k]) = 1 ) or
           (pos(cEXAMPLE,CommentStrList[k]) = 1 )then begin
          faqA.add('[A'+IntToStr(TitleIndex)+']');
          repeat
            faqA.add(CommentStrList[k]);
            inc(k);
          until (k >= l);
          dec(k);
        end;
        inc(k);
      until k > l;
      CommentStrList.Free;
      CommentStrList := NIL;
    end;
  inc(i);
  until i >= j;
end;

procedure TForm1.TitlePanelDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := false;
  if TComponent(Sender).tag < 100 then begin
    if Source = VSplitpanel1 then begin
      Accept := true;
      TitlePanel.Height := Y + (Sender as TControl).Top;
    end;
    if (Source = VSplitPanel2) and
       ((Sender = sgTitle) or (Sender = mQuestion) ) then begin
      Accept := true;
      sgTitle.Height := Y + (Sender as TControl).Top;
    end;
  end
  else begin
      accept := true;
  end;
end;

procedure TForm1.mAnswerDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  TitlePanel.Height := Y + (Sender as TControl).Top;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  sgTitle.ColWidths[1] := TitlePanel.Width - sgTitle.ColWidths[0];

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  faqQ.free;
  faqT.free;
  faqA.free;
end;

{StringGridɕ\ĂFAQ^CgNbNꂽ
 eA񓚂\}
procedure TForm1.sgTitleClick(Sender: TObject);
var
  i,j:LongInt;
  currentQ,
  currentA: Tstringlist;
  s,
  nextQ,
  nextA,
  searchQ,
  searchA: string;
  endSearch: boolean;
begin
  currentQ := TstringList.Create;
  currentA := TstringList.Create;
  nextQ := '[Q'+IntToStr(sgTitle.Row+1)+']';
  nextA := '[A'+IntToStr(sgTitle.Row+1)+']';
  searchQ := '[Q'+IntToStr(sgTitle.Row)+']';
  searchA := '[A'+IntToStr(sgTitle.Row)+']';

  {Y鎿e𔲂o}
  j := faqQ.count-1;
  i := 0;
  endSearch := false;
  repeat
    s := faqQ[i];
    if pos(searchQ,s) > 0 then begin
      inc(i);
      repeat
        currentQ.Add(faqQ[i]);
        inc(i);
      until (pos(nextQ,faqQ[i]) > 0) or (i >= j);
      endSearch := true;
    end;
    inc(i);
  until (i >= j) or endSearch;

  {Y񓚓e𔲂o}
  j := faqA.count-1;
  i := 0;
  endSearch := false;
  repeat
    s := faqA[i];
    if pos(searchA,s) > 0 then begin
      inc(i);
      repeat
        currentA.Add(faqA[i]);
        inc(i);
      until (pos(nextA,faqA[i]) > 0) or (i >= j);
      endSearch := true;
    end;
    inc(i);
  until (i >= j) or endSearch;
  mQuestion.Lines := currentQ;
  mAnswer.Lines := currentA;
  currentQ.Free;
  currentA.Free;
end;

{ݒʂ̕\}
procedure TForm1.ItemSetupClick(Sender: TObject);
begin
  ConfigureForm := TConfigureForm.Create(Self);
  with ConfigureForm do begin
    Edit1.Text := sgTitle.Font.Name;
    Edit2.Text := mQuestion.Font.Name;
    Edit3.Text := mAnswer.Font.Name;
  end;
  if ConfigureForm.ShowModal = mrOK then begin
    sgTitle.Font :=ConfigureForm.FontAry[1];
    mQuestion.Font := ConfigureForm.FontAry[2];
    mAnswer.Font := ConfigureForm.FontAry[3];
  end;
  ConfigureForm.Release;
end;

procedure TForm1.ItemQuitClick(Sender: TObject);
begin
  Close;
end;

end.
